"""
Nazwa: EKG-Priv
Licencja: GPL

Autorzy:
DevNull (devnull2 at o2 dot pl)
mi_shell (mi_shell at o2 dot pl)


Zalecane ustawienia w ekg:
alias -a >>ekg-priv /^msg >>ekg-priv %1
bind -a F9 >>ekg-priv wo

"""

import ekg, string, os
from time import strftime, localtime

app_name = ">>ekg-priv"

#Wersja skryptu
ver = "0.1rc2w2"

#Bez komentarza :]
haslo = "test123"

#Plik z wiadomosciami od userow bez autoryzacji 
log_file = "ekg-priv.log" 

#Plik z UIN`ami, ktore sa automagicznie autoryzowane podczas uruchomienia skryptu
uins_auth_file = "ekg-priv.allowed"

#Lista z autoryzowanymi UIN`ami podczas dzialania skryptu. Po jego wyladowaniu lista jest czyszczona
uins_auth_list = []

#Lista z UIN`ami oczekujacymi na autoryzacje
uins_wait_list = []

#Zmienna przechowujaca UIN z pliku
uinf = ''

wait_opt = 0

#Sciezka do edytora
editor_path = "/usr/bin/emacs"

#Tresc wysylanego komunikatu po podaniu przez usera nieprawidlowego hasla
MSG_NO_AUTH = "[EKG-Priv] Zeby ze mna porozmawiac wymagane jest podanie hasla. Wpisz haslo i nacisnij [ENTER] (tak jak wysylasz zwykla wiadomosc). Jezeli nie znasz hasla wpisz: prosze_o_haslo -  wtedy Twoja prosba zostanie rozpatrzona."

#Tresc wysylanego komunikatu po podaniu przez usera poprawnego hasla
MSG_AUTH = "[EKG-Priv] Zostales autoryzowany. Slucham Cie..."


def init():
    ekg.printf("generic", "EKG-Priv %s \x1b[32m\x1b[1m[ON]" % ver)
    ekg.printf("generic", "\x1b[1mEKG-Priv:\x1b[0m \x1b[33mNacisnij klawisz kontroli skryptu, a nastepnie wpisz\x1b[0m 'h' \x1b[33maby uzyskac pomoc.\n")
                               
               
    fa = open(os.getcwd()+ "/.gg/scripts/" + uins_auth_file, 'r')
    ekg.printf("generic", "\x1b[32m.------------------------------------------------------------.\x1b[0m")
    ekg.printf("generic", "\x1b[32m|\x1b[0m EKG-Priv: Podane UIN`y zostaly automatycznie autoryzowane:\x1b[32m |\x1b[0m")
    ekg.printf("generic", "\x1b[32m`------------------------------------------------------------'\x1b[0m")
    while 1:
        uinf = fa.readline()
        if uinf == '':
            break
            
        if uinf != '':
            uins_auth_list.append(uinf[:-1])
        
        else:
           ekg.printf("generic", "\x1b[31Brak zdefiniowanych UIN`ow do automatycznej autoryzacji!\x1b[0m")
           
    fa.close()

    for i in range(len(uins_auth_list)):
        ekg.printf("generic",  "[%d] \x1b[35m%s \x1b[0m" % (i+1,uins_auth_list[i]))     
       
       
    
   
    
        
def deinit():
    ekg.printf("generic", "EKG-Priv \x1b[31m\x1b[1m[OFF]")


def handle_msg(uin, name, msgclass, text, time, secure):
    global uins_wait_list
                
    if string.count(uins_auth_list, uin) >= 1:
             
        return (uin, name, msgclass, text, time, secure)
   
    else:

        if text == "prosze_o_haslo":
            ekg.printf("generic","\x1b[33mUzytkownik\x1b[0m %s/%d \x1b[33mprosi o haslo!\x1b[0m" % (name,uin))
            if not uin in uins_wait_list:
                uins_wait_list.append(uin)
            return 0
    
        if text != haslo:
            czas = strftime("[%d %b %Y-%H:%M:%S]", localtime())
            fl = open(os.getcwd()+ "/.gg/scripts/" +log_file, "a+")
            fl.write("%s:%s/%s: %s\n" % (czas, name, uin,text))
            fl.close()
            ekg.command("/^msg %d %s" % (uin, MSG_NO_AUTH))
            ekg.printf("generic", "\x1b[34m%s/%d\x1b[0m \x1b[33mnie zostal autoryzowany [bledne haslo]\x1b[0m" % (name,uin))
            if not uin in uins_wait_list:
                uins_wait_list.append(uin)
            
            return 0
           
                 
        if text == haslo:
            text = "haslo: ********"
            uins_auth_list.append(uin)
            ekg.command("/^msg %d %s" % (uin, MSG_AUTH))
            ekg.printf("generic", "\x1b[34m%s/%d\x1b[0m \x1b[33mzostal autoryzowany..\x1b[0m" % (name,uin))
            if uin in uins_wait_list:
                del uins_wait_list[(uins_wait_list.index(uin))]
            
            
            return (uin, name, msgclass, text, time, secure)



def handle_msg_own(rcpts, text):
    global wait_opt, app_name

    if rcpts == app_name:
        
        if text == "wo":
            wait_opt = 1
            ekg.printf("generic", "\x1b[1m>>EKG-Priv\x1b[0m")
        else:
            exec_cmd(text)
            
        return 0
                       

    if wait_opt == 1:
        exec_cmd(text)
        wait_opt = 0
        return 0




def exec_cmd(text):

    if text == "l":
        show_auth_list()
            
    elif (text == "df") or (text == "d"):
        del_first_uin()  
            
    elif text == "dl":
        del_last_uin()
        
    elif text == "dd":
        del_all_uins()

    elif text[0] == "d" and text[1] != "d" and text[1] != "l" and text[1] != "f":
        num = text[1:]
        del_n_uin(int(num))
          
    elif text == "w":
        show_wait_list()    
            
    elif (text == "af") or (text == "a"):
        auth_first_uin()
        
    elif text == "al":
        auth_last_uin()
        
    elif text == "aa":
        auth_all_uins()

    elif text[0] == "a" and text[1] != "a" and text[1] != "l" and text[1] != "f":
        num = text[1:]
        auth_n_uin(int(num))

    elif text == "e":
        os.system(editor_path + " " + os.getcwd()+ "/.gg/scripts/" + log_file + " 2> /dev/null")
        
    elif text == "h":
        help()
        
    else:
        ekg.printf("generic", "\x1b[1mEKG-Priv:\x1b[0m \x1b[31mBledna opcja. Nacisnij klawisz kontroli skryptu, a nastepnie wpisz\x1b[0m 'h' \x1b[31maby uzyskac pomoc.")

            

def show_auth_list():
    global uins_auth_list
    
    if len(uins_auth_list) > 0:
        ekg.printf("generic", "\x1b[1m[l] EKG-Priv:\x1b[0m Autoryzowane UIN`y:\n")
        for i in range(len(uins_auth_list)):
            ekg.printf("generic",  "[%d] \x1b[34m%s \x1b[0m" % (i+1,uins_auth_list[i]))
    else:
        ekg.printf("generic", "\x1b[1m[l]\x1b[0m \x1b[31mEKG-Priv: Brak autoryzowanych UIN`ow !\x1b[0m")




def show_wait_list():
    global uins_wait_list
    
    
    if len(uins_wait_list) > 0:
        ekg.printf("generic", "\x1b[1m[w] EKG-Priv:\x1b[0m UIN`y oczekujace na autoryzacje:\n")
        for i in range(len(uins_wait_list)):
            ekg.printf("generic",  "[%d] \x1b[33m%s \x1b[0m" % (i+1,uins_wait_list[i]))
        
    else:
        ekg.printf("generic", "\x1b[1m[w] EKG-Priv:\x1b[0m \x1b[31mBrak UIN`ow oczekujacych na autoryzacje!\x1b[0m")
        


def auth_first_uin():
    global uins_auth_list, uins_wait_list

    if len(uins_wait_list) == 0:
        ekg.printf("generic", "\x1b[1m[af] EKG-Priv:\x1b[0m \x1b[31mBrak UIN'ow do autoryzacji!\x1b[0m")
    else:    
        if not uins_wait_list[0] in uins_auth_list:
            uins_auth_list.append(uins_wait_list[0])
            ekg.printf("generic", "\x1b[1m[af] EKG-Priv:\x1b[0m \x1b[33mUIN\x1b[0m \x1b[34m%s\x1b[0m \x1b[33mzostal autoryzowany.\x1b[0m" % uins_wait_list[0])    
            del uins_wait_list[0]



def auth_last_uin():
    global uins_auth_list, uins_wait_list

    if len(uins_wait_list) == 0:
        ekg.printf("generic", "\x1b[1m[al] EKG-Priv:\x1b[0m \x1b[31mBrak UIN`ow do autoryzacji!\x1b[0m")
    else:
        pop = uins_wait_list.pop()
        if not pop in uins_auth_list:
            uins_auth_list.append(pop)
            ekg.printf("generic", "\x1b[1m[al] EKG-Priv\x1b[0m:\x1b[33m UIN\x1b[0m \x1b[34m%s\x1b[0m \x1b[33mzostal autoryzowany.\x1b[0m" % pop)


def auth_n_uin(n):
    global uins_auth_list, uins_wait_list

    if n-1 > uins_wait_list.index(uins_wait_list[-1]):
        ekg.printf("generic", "\x1b[1m[aN] EKG-Priv:\x1b[0m \x1b[33mUIN o numerze\x1b[0m %d \x1b[33mnie istnieje!\x1b[0m" % n)
    else:
        uins_auth_list.append(uins_wait_list[n-1])
        ekg.printf("generic", "\x1b[1m[aN] EKG-Priv:\x1b[0m \x1b[33mUIN\x1b[0m \x1b[34m%d\x1b[0m \x1b[33mzostal autoryzowany.\x1b[0m" % uins_wait_list[n-1])
        uins_wait_list.pop(n-1)

def auth_all_uins():
    global uins_auth_list, uins_wait_list

    tmp_uins_list = []

    if len(uins_wait_list) == 0:
        ekg.printf("generic", "\x1b[1m[aa] EKG-Priv:\x1b[0m \x1b[31mBrak UIN`ow do autoryzacji!\x1b[0m")
    else:
        for i in uins_wait_list:
            if not i in uins_auth_list:
                uins_auth_list.append(i)
                tmp_uins_list.append(i)
        ekg.printf("generic", "\x1b[1m[aa] EKG-Priv\x1b[0m: \x1b[33mNastepujace UIN`y zostaly autoryzowane:\x1b[0m\n")
        ekg.printf("generic", str(tmp_uins_list))
        uins_wait_list = []

def del_first_uin():
    global uins_auth_list
    
    if len(uins_auth_list) == 0:
        ekg.printf("generic", "\x1b[1m[df] EKG-Priv\x1b[0m: \x1b[31mBrak elementow do usuniecia!\x1b[1m")
    else:
        ekg.printf("generic", "\x1b[1m[df] EKG-Priv\x1b[0m: \x1b[33mPierwszy autoryzowany UIN (\x1b[0m\x1b[34m%s\x1b[1m\x1b[33m) zostal usuniety.\x1b[0m" % uins_auth_list[0])
        del uins_auth_list[0]
        

def del_last_uin():
    global uins_auth_list
    
    if len(uins_auth_list) == 0:
        ekg.printf("generic", "\x1b[1m[d] EKG-Priv\x1b[0m: \x1b[31mBrak elementow do usuniecia!\x1b[0m")
    else:
        pop = uins_auth_list.pop()
        ekg.printf("generic", "\x1b[1m[d] EKG-Priv\x1b[0m: \x1b[33mOstatni autoryzowany UIN (\x1b[0m\x1b[34m%s\x1b[0m\x1b[33m) zostal usuniety.\x1b[0m" % pop)


def del_n_uin(n):
    global uins_auth_list
    if n-1 > uins_auth_list.index(uins_auth_list[-1]):
        ekg.printf("generic", "\x1b[1m[d%d] EKG-Priv:\x1b[0m \x1b[33mUIN o numerze\x1b[0m %d \x1b[33mnie istnieje!\x1b[0m" % n)
    else:
        ekg.printf("generic", "\x1b[1m[d%d] EKG-Priv:\x1b[0m \x1b[33mUIN\x1b[0m \x1b[34m[%d]%s \x1b[0m \x1b[33mzostal usuniety.\x1b[0m" % (n,uins_auth_list[n-1])) 
        uins_auth_list.pop(n-1)

def del_all_uins():
    global uins_auth_list

    ekg.printf("generic", "\x1b[1m[dd] EKG-Priv:\x1b[0m \x1b[33mWszystkie autoryzowane UIN`y zostaly usuniete.\x1b[0m")
    uins_auth_list = []

def help():
    ekg.printf("generic", "\x1b[32m.-----------------------------------------------.\x1b[0m")
    ekg.printf("generic", "\x1b[32m|\x1b[0m Sterowanie EKG-Priv - lista dostepnych opcji: \x1b[32m|\x1b[0m")
    ekg.printf("generic", "\x1b[32m`-----------------------------------------------'\x1b[0m")
    ekg.printf("generic", "")
    ekg.printf("generic", "\x1b[1m'af'\x1b[0m\x1b[31m -\x1b[0m autoryzuje pierwszy UIN z listy oczekujacych (lub: 'a')")
    ekg.printf("generic", "\x1b[1m'aa'\x1b[0m\x1b[31m -\x1b[0m autoryzuje wszystkie UIN`y z listy oczekujacych")
    ekg.printf("generic", "\x1b[1m'al'\x1b[0m\x1b[31m -\x1b[0m autoryzuje ostatni UIN z listy oczekujacych")
    ekg.printf("generic", "\x1b[1m'aN'\x1b[0m\x1b[31m -\x1b[0m autoryzuje N-ty UIN z listy oczekujacych")
    ekg.printf("generic", "\x1b[1m'l'\x1b[0m \x1b[31m -\x1b[0m lista autoryzowanych UIN`ow ")
    ekg.printf("generic", "\x1b[1m'df'\x1b[0m\x1b[31m -\x1b[0m usuwa pierwszy autoryzowany UIN (lub: 'd')")
    ekg.printf("generic", "\x1b[1m'dl'\x1b[0m\x1b[31m -\x1b[0m usuwa ostatni autoryzowany UIN ")
    ekg.printf("generic", "\x1b[1m'dd'\x1b[0m\x1b[31m -\x1b[0m usuwa wszystkie autoryzowane UIN`y ")
    ekg.printf("generic", "\x1b[1m'dN'\x1b[0m\x1b[31m -\x1b[0m usuwa N-ty autoryzowany UIN ")
    ekg.printf("generic", "\x1b[1m'e'\x1b[0m \x1b[31m -\x1b[0m otwiera plik log w zdefiniowanym edytorze ")
    ekg.printf("generic", "\x1b[1m'w'\x1b[0m \x1b[31m -\x1b[0m lista UIN`ow oczekujacych na autoryzacje")
    ekg.printf("generic", "\x1b[1m'h'\x1b[0m \x1b[31m -\x1b[0m wyswietla pomoc ")
    

                       

        
        

                       
        
        
